/*
 * Copyright (c) 2010, Koji Tsukada<tsuka@mobiquitous.com> 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification, 
 * are permitted provided that the following conditions are met:
 * 
 * 1. Redistributions of source code must retain the above copyright notice, 
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 *    this list of conditions and the following disclaimer in the documentation 
 *    and/or other materials provided with the distribution.
 *    
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND 
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF 
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED 
 * OF THE POSSIBILITY OF SUCH DAMAGE.
*/

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Text;
using System.Windows.Forms;

using System.Text.RegularExpressions;
using System.IO;
using System.Collections;

namespace MobiServer.Devices.DMX
{

    public partial class ControlChannel : MobiServer.ControlBase
    {
        #region Constants/Variables
   
        int channel;
        ControlDevice parentDevice = null;

        public int Channel
        {
            get { return channel; }
        }

        public byte Value
        {
            get { return (byte)numericUpDownValue.Value; }
            set { numericUpDownValue.Value = (decimal)value; }
        }
        
        #endregion
   

        #region Constructor/Destructor
        public ControlChannel()
        {
            InitializeComponent();
        }

        public ControlChannel(MessageControl messageControl, ControlDevice device, int channel, byte value)
            : base(messageControl)
        {
            InitializeComponent();
            this.parentDevice = device;
            this.channel = channel;
            numericUpDownValue.Value = (decimal)value;
        }

        private void ControlChannel_Load(object sender, EventArgs e)
        {
            //SetControlText(this.channel.ToString());
        }

        #endregion

        private void trackBarValue_Scroll(object sender, EventArgs e)
        {
            numericUpDownValue.Value = (decimal)trackBarValue.Value;
        }

        private void numericUpDownValue_ValueChanged(object sender, EventArgs e)
        {
            if (trackBarValue.Value != (int)numericUpDownValue.Value)
            {
                trackBarValue.Value = (int)numericUpDownValue.Value;
            }
            parentDevice.SendCommand(channel-1, (int)numericUpDownValue.Value);

        }

        public bool CheckAddress(int channel)
        {
            if (channel == this.Channel)
            {
                return true;
            }
            else
            {
                return false;
            }
        }

    }
}
